﻿using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Collections.ObjectModel;
using System.Web.UI.HtmlControls;
using System.Drawing;
using System.Web.UI.WebControls;
using System.Web.UI;

namespace MS_OSPFM
{
    public partial class HighlightFeature : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                //Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                //Map1.MapUnit = GeographyUnit.DecimalDegree;

                //ShapeFileFeatureLayer lineLayer = new ShapeFileFeatureLayer(MapPath("~/Data/Post5953Data/LineLayer.shp"));
                //lineLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Canal1;
                //lineLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                //ShapeFileFeatureLayer pointLayer = new ShapeFileFeatureLayer(MapPath("~/Data/Post5953Data/PointLayer.shp"));
                //pointLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimpleCircleStyle(GeoColor.StandardColors.DarkBlue, 6);
                //pointLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                //InMemoryFeatureLayer recLayer = new InMemoryFeatureLayer();
                //recLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.FillSolidBrush.Color = GeoColor.FromArgb(30, GeoColor.StandardColors.DarkBlue);
                //recLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                //Map1.StaticOverlay.Layers.Add("line", lineLayer);
                //Map1.StaticOverlay.Layers.Add("point", pointLayer);
                //Map1.StaticOverlay.Layers.Add("rec", recLayer);
                //Map1.StaticOverlay.TileType = TileType.SingleTile;

                //lineLayer.Open();
                //pointLayer.Open();
                //RectangleShape extent = lineLayer.GetBoundingBox();
                //extent.ExpandToInclude(pointLayer.GetBoundingBox());
                //lineLayer.Close();
                //pointLayer.Close();

                //Map1.CurrentExtent = extent;
                //===============

                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
                Map1.MapUnit = GeographyUnit.Meter;

                ShapeFileFeatureLayer lyr_lines_FS_LD = new ShapeFileFeatureLayer(Server.MapPath("~/Data/FS_LD.shp"));
                lyr_lines_FS_LD.ZoomLevelSet.ZoomLevel05.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Blue, 1.5f, true);
                lyr_lines_FS_LD.ZoomLevelSet.ZoomLevel05.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_lines_FS_LD.DrawingMarginPercentage = 50;
                lyr_lines_FS_LD.IsVisible = true;

                ShapeFileFeatureLayer lyr_points_Access_Point = new ShapeFileFeatureLayer(MapPath("~/Data/Access_Points.shp"));
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.SimpleColors.Blue, 12f);
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_points_Access_Point.DrawingMarginPercentage = 50;
                lyr_points_Access_Point.IsVisible = true;

                InMemoryFeatureLayer rectLayer = new InMemoryFeatureLayer();
                rectLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.FillSolidBrush.Color = GeoColor.FromArgb(30, GeoColor.StandardColors.DarkBlue);
                rectLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                Proj4Projection proj4_points_Access_Points = new Proj4Projection();
                proj4_points_Access_Points.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_points_Access_Points.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_points_Access_Point.FeatureSource.Projection = proj4_points_Access_Points;

                Proj4Projection proj4_lines_FS_LD = new Proj4Projection();
                proj4_lines_FS_LD.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_lines_FS_LD.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_lines_FS_LD.FeatureSource.Projection = proj4_lines_FS_LD;

                Proj4Projection proj4_rectLayer = new Proj4Projection();
                proj4_rectLayer.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_rectLayer.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                rectLayer.FeatureSource.Projection = proj4_rectLayer;

                Proj4Projection proj4ForShapes = new Proj4Projection();
                proj4ForShapes.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4ForShapes.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                proj4ForShapes.Open();

                Map1.EditOverlay.FeatureSource.Projection = proj4ForShapes;

                LayerOverlay layerOverLay = new LayerOverlay("OSPFM Layers");
                layerOverLay.IsBaseOverlay = false;
                layerOverLay.ClientCache.CacheId = "OSPFM_Layers";
                layerOverLay.TransitionEffect = TransitionEffect.None;

                layerOverLay.Layers.Add("Lyr_FS_LD", lyr_lines_FS_LD);
                layerOverLay.Layers.Add("Lyr_Access_Point", lyr_points_Access_Point);
                layerOverLay.Layers.Add("rectLayer", rectLayer);
                layerOverLay.TileType = TileType.SingleTile;

                //Create VE layer and to Map1
                VirtualEarthOverlay ve = new VirtualEarthOverlay("VirtualEarth Map");
                ve.VirtualEarthMapType = VirtualEarthMapType.Birdseye;

                Map1.CustomOverlays.Add(layerOverLay);
                Map1.CustomOverlays.Add(ve);
                //===============
            }
        }

        protected void Map1_TrackShapeFinished(object sender, EventArgs e)
        {
            panel.Controls.Clear();
            if (Map1.EditOverlay.Features.Count != 0)
            {
                RectangleShape rectangle = Map1.EditOverlay.Features[0].GetBoundingBox();

                ShapeFileFeatureLayer lineLayer = (ShapeFileFeatureLayer)((LayerOverlay)Map1.CustomOverlays[0]).Layers["Lyr_FS_LD"];
                ShapeFileFeatureLayer pointLayer = (ShapeFileFeatureLayer)((LayerOverlay)Map1.CustomOverlays[0]).Layers["Lyr_Access_Point"];
                InMemoryFeatureLayer recLayer = (InMemoryFeatureLayer)((LayerOverlay)Map1.CustomOverlays[0]).Layers["rectLayer"];

                lineLayer.Open();
                pointLayer.Open();
                recLayer.Open();
                Collection<Feature> lineFeatures = lineLayer.QueryTools.GetFeaturesIntersecting(rectangle, ReturningColumnsType.AllColumns);
                Collection<Feature> pointFeatures = pointLayer.QueryTools.GetFeaturesIntersecting(rectangle, ReturningColumnsType.AllColumns);
                recLayer.InternalFeatures.Clear();
                recLayer.InternalFeatures.Add(new Feature(rectangle));

                lineLayer.Close();
                pointLayer.Close();
                recLayer.Close();

                AddList(lineFeatures);
                AddList(pointFeatures);
            }

            Map1.EditOverlay.Features.Clear();
        }

        void AddList(Collection<Feature> features)
        {
            if (features.Count != 0)
            {
                WellKnownType featureType = features[0].GetWellKnownType();
                string shapeTypeString = (featureType == WellKnownType.Point ? "Points" : "Lines");

                System.Web.UI.WebControls.Label label = new System.Web.UI.WebControls.Label();
                label.Text = shapeTypeString + "<br/>";
                label.Font.Size = 10;
                panel.Controls.Add(label);
                foreach (Feature feature in features)
                {
                    LiteralControl br = new LiteralControl("<br/>");
                    HtmlAnchor anchor = new HtmlAnchor();
                    anchor.InnerHtml = feature.ColumnValues["Name"];
                    anchor.HRef = "#";
                    anchor.Attributes.Add("wkt", feature.GetWellKnownText());
                    anchor.Attributes.Add("onmouseover", "linkOver(this)");
                    anchor.Attributes.Add("onmouseout", "linkOut()");

                    panel.Controls.Add(anchor);
                    panel.Controls.Add(br);
                }
            }
        }

    }
}
